
(rule
 (targets environment.ml)
 (action
  (write-file %{targets}
              "module Name = struct let name = \"%%VERSION%%\" end
include Tezos_protocol_environment.MakeV1(Name)()
module CamlinternalFormatBasics = struct include CamlinternalFormatBasics end
")))

(rule
 (targets registerer.ml)
 (deps %%SOURCES%%
       (:src_dir TEZOS_PROTOCOL))
 (action
  (with-stdout-to %{targets}
                  (chdir %{workspace_root} (run %{bin:tezos-embedded-protocol-packer} "%{src_dir}" "%%LIB_VERSION%%")))))

(rule
 (targets functor.ml)
 (deps %%SOURCES%%
       (:src_dir TEZOS_PROTOCOL))
 (action (with-stdout-to %{targets}
                         (chdir %{workspace_root}
                                (run %{bin:tezos-protocol-compiler.tezos-protocol-packer} %{src_dir})))))

(rule
 (targets protocol.ml)
 (deps %%SOURCES%%)
 (action
  (write-file %{targets}
    "module Environment = Tezos_protocol_environment_%%LIB_VERSION%%.Environment
let hash = Tezos_crypto.Protocol_hash.of_b58check_exn \"%%HASH%%\"
let name = Environment.Name.name
include Tezos_raw_protocol_%%LIB_VERSION%%
include Tezos_raw_protocol_%%LIB_VERSION%%.Main
")))

(library
 (name tezos_protocol_environment_%%LIB_VERSION%%)
 (public_name tezos-protocol-%%VERSION%%.environment)
 (library_flags (:standard -linkall))
 (libraries tezos-protocol-environment)
 (modules Environment))

(library
 (name tezos_raw_protocol_%%LIB_VERSION%%)
 (public_name tezos-protocol-%%VERSION%%.raw)
 (libraries tezos_protocol_environment_%%LIB_VERSION%%)
 (library_flags (:standard -linkall))
 (flags (:standard -nopervasives -nostdlib
                   -w +a-4-6-7-9-29-32-40..42-44-45-48
                   -warn-error -a+8
                   -open Tezos_protocol_environment_%%LIB_VERSION%%__Environment
                   -open Pervasives
                   -open Error_monad))
 (modules Source %%MODULES%%))

(install
 (section lib)
 (package tezos-protocol-%%VERSION%%)
 (files (TEZOS_PROTOCOL as raw/TEZOS_PROTOCOL)))

(library
 (name tezos_protocol_%%LIB_VERSION%%)
 (public_name tezos-protocol-%%VERSION%%)
 (libraries
      tezos-protocol-environment
      tezos-protocol-environment-sigs
      tezos_raw_protocol_%%LIB_VERSION%%)
 (flags -w "+a-4-6-7-9-29-40..42-44-45-48"
        -warn-error "-a+8"
        -nopervasives)
 (modules Protocol))

(library
 (name tezos_protocol_%%LIB_VERSION%%_functor)
 (public_name tezos-protocol-%%VERSION%%.functor)
 (libraries
      tezos-protocol-environment
      tezos-protocol-environment-sigs
      tezos_raw_protocol_%%LIB_VERSION%%)
 (flags -w "+a-4-6-7-9-29-40..42-44-45-48"
        -warn-error "-a+8"
        -nopervasives)
 (modules Functor))

(library
 (name tezos_embedded_protocol_%%LIB_VERSION%%)
 (public_name tezos-embedded-protocol-%%VERSION%%)
 (library_flags (:standard -linkall))
 (libraries tezos-protocol-%%VERSION%%
            tezos-protocol-updater
            tezos-protocol-environment)
 (flags (:standard -w +a-4-6-7-9-29-32-40..42-44-45-48
                   -warn-error -a+8))
 (modules Registerer))

(alias
 (name runtest_sandbox)
 (deps .tezos_protocol_%%LIB_VERSION%%.objs/native/tezos_protocol_%%LIB_VERSION%%.cmx))
